﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Float {
  using Common;
  using Data;
  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class FloatConstantErc : ConstantsWeightedErc<double, DoubleArray> {

    public FloatConstantErc() : this(false, 1d) { }

    public FloatConstantErc(params double[] constants) : this(true, 1d, constants) { }

    public FloatConstantErc(bool isEnabled, double weight = 1d, params double[] constants)
      : base(isEnabled, new DoubleArray(constants), weight) {
    }

    [StorableConstructor]
    public FloatConstantErc(bool deserializing) : base(deserializing) { }

    public FloatConstantErc(FloatConstantErc origin, Cloner cloner) : base(origin, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new FloatConstantErc(this, cloner);
    }
  }
}
