﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Integer {
  using Common;
  using Data;
  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class IntegerConstantErc : ConstantsWeightedErc<int, IntArray> {

    public IntegerConstantErc() : this(false, 1d) { }

    public IntegerConstantErc(params int[] constants) : this(true, 1d, constants) { }

    public IntegerConstantErc(bool isEnabled, double weight = 1d, params int[] constants)
      : base(isEnabled, new IntArray(constants), weight) {
    }

    [StorableConstructor]
    public IntegerConstantErc(bool deserializing) : base(deserializing) { }

    public IntegerConstantErc(IntegerConstantErc origin, Cloner cloner) : base(origin, cloner) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new IntegerConstantErc(this, cloner);
    }
  }
}
